package com.sky.ioc.service.Parking.impl;

import com.sky.ioc.entity.domain.parking.IllegalParking;
import com.sky.ioc.entity.domain.parking.Parking;
import com.sky.ioc.mapper.IllegalParkingMapper;
import com.sky.ioc.mapper.job.TokenMapper;
import com.sky.ioc.service.Parking.IllegalParkingService;
import com.sky.ioc.tool.ReturnMsg;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.concurrent.ThreadLocalRandom;

@Service
@Slf4j
public class IllegalParkingServiceImpl implements IllegalParkingService {


    @Autowired
    TokenMapper tokenMapper;

    @Value("${sky.dataIp}")
    private String dataIp;

    @Autowired
    IllegalParkingMapper illegalParkingMapper;

    final static  String ILLEGAL_PARKING_URL="%s/api/parking/PARKING/illegalParking/list";
    @Override
    public ReturnMsg getIllegalParkingData() {
        String url =   String.format(ILLEGAL_PARKING_URL,"http://"+dataIp)+"??pageNum=1&pageSize=1000";
        Map<String,String> tokenMap = tokenMapper.getNewToken();
        String token ="Bearer eyJhbGciOiJIUzUxMiJ9.eyJ1c2VyX2lkIjoxLCJ1c2VyX2tleSI6IjUwZTU1NTRkLWJjYzYtNGRhMS1iZDUxLWFhNTc3YzU4YTFiNCIsInVzZXJuYW1lIjoiYWRtaW4ifQ.X10VPYJfeeRTka7OtqNPOGMpL4QkW3fR_TfCKXCmO-yXbIIrr_40fcwiVnpXfYVENo_BvXWEACRd-Y6nXsbkog";
        if(tokenMap!=null){
            token = "Bearer "+tokenMap.get("token");
        }
        // 创建一个请求头对象
        HttpHeaders httpHeaders = new HttpHeaders();
        // 设置参数
        httpHeaders.set("authorization", token);
        // 创建一个响应体对象
        HttpEntity<String> httpEntity = new HttpEntity(httpHeaders);
        // 3.创建RestTemplate
        RestTemplate restTemplate = new RestTemplate();
        // 发送GET请求
        ResponseEntity<Map> responseEntity = restTemplate.exchange(url, HttpMethod.GET, httpEntity, Map.class);
        // 获取响应对象里的 body 对象
        Map<String, Object> body = responseEntity.getBody();
        // 获取状态码
        Integer code = (Integer)body.get("code");
        // 获取响应信息
        String message = (String)body.get("msg");
        if(code==200){
            ThreadLocalRandom random = ThreadLocalRandom.current();
            ArrayList list = (ArrayList) body.get("rows");
            if(list!=null&&list.size()>0){
                illegalParkingMapper.delete(null);
                for (int i=0;i<list.size();i++){
                    LinkedHashMap json = (LinkedHashMap) list.get(i);
                    IllegalParking illegalParking = new IllegalParking();
                    illegalParking.setId((Integer) json.get("id"));
                    illegalParking.setLicencePlate(String.valueOf(json.get("illegalCardnumber")));
                    illegalParking.setIllegalTime(String.valueOf(json.get("illegalTime")));
                    illegalParking.setManagerTime(String.valueOf(json.get("managerTime")));
                    illegalParking.setIllegalReason(String.valueOf(json.get("illegalReason")));
                    illegalParkingMapper.insert(illegalParking);
                }
            }
            return ReturnMsg.ok();

        }else{
            log.info("获取违停数据："+message);
            return  ReturnMsg.fail(message);
        }
    }
}
